<?php
##########################################################################
##      NagVis WUI - Addon to edit the configuration in the browser     ##
##########################################################################
## index.php - Main file to get called by the user			            ##
##########################################################################
## Licenced under the terms and conditions of the GPL Licence,         	##
## please see attached "LICENCE" file	                                ##
##########################################################################

##########################################################################
## For developer guidlines have a look at http://www.nagvis.org			##
##########################################################################

@session_start();

require("/usr/share/nagvis/includes/defines/global.php");
require("/usr/share/nagvis/includes/defines/matches.php");

require("/usr/share/nagvis/includes/functions/debug.php");

require("/usr/share/nagvis/includes/classes/GlobalMainCfg.php");
require("/usr/share/nagvis/includes/classes/GlobalMapCfg.php");
require("/usr/share/nagvis/includes/classes/GlobalLanguage.php");
require("/usr/share/nagvis/includes/classes/GlobalPage.php");
require("/usr/share/nagvis/includes/classes/GlobalMap.php");
require("/usr/share/nagvis/includes/classes/GlobalBackground.php");
require("/usr/share/nagvis/includes/classes/GlobalGraphic.php");

require("/usr/share/nagvis/wui/includes/classes/WuiMainCfg.php");
require("/usr/share/nagvis/wui/includes/classes/WuiMapCfg.php");

$MAINCFG = new WuiMainCfg(CONST_MAINCFG);

// If not set, initialize $_GET['page']
if(!isset($_GET['page'])) {
	$_GET['page'] = '';	
}

// Display the wanted page, if nothing is set, display the map
switch($_GET['page']) {
	case 'edit_config':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui//includes/classes/WuiEditMainCfg.php");
		
		$FRONTEND = new WuiEditMainCfg($MAINCFG);
		$FRONTEND->getForm();
		$FRONTEND->printPage();
	break;
	case 'shape_management':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiShapeManagement.php");
		$FRONTEND = new WuiShapeManagement($MAINCFG);
		$FRONTEND->getForm();
	break;
	case 'background_management':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiBackgroundManagement.php");
		$FRONTEND = new WuiBackgroundManagement($MAINCFG);
		$FRONTEND->getForm();
	break;
	case 'map_management':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiMapManagement.php");
		$FRONTEND = new WuiMapManagement($MAINCFG);
		$FRONTEND->getForm();
	break;
	case 'backend_management':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiBackendManagement.php");
		$FRONTEND = new WuiBackendManagement($MAINCFG);
		$FRONTEND->getForm();
	break;
	case 'addmodify':
		require("/usr/share/nagvis/includes/classes/GlobalForm.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiAddModify.php");
		
		$MAPCFG = new WuiMapCfg($MAINCFG,$_GET['map']);
		$MAPCFG->readMapConfig();
		
		if(!isset($_GET['coords'])) {
			$_GET['coords'] = '';
		}
		if(!isset($_GET['id'])) {
			$_GET['id'] = '';
		}
		
		$FRONTEND = new WuiAddModify($MAINCFG,$MAPCFG,Array('action' => $_GET['action'],
															'type' => $_GET['type'],
															'id' => $_GET['id'],
															'coords' => $_GET['coords']));
		$FRONTEND->getForm();
	break;
	default:
		require("/usr/share/nagvis/wui/includes/classes/WuiFrontend.php");
		require("/usr/share/nagvis/wui/includes/classes/WuiMap.php");
		
		if(!isset($_GET['map'])) {
			$_GET['map'] = '';	
		}
		
		$MAPCFG = new WuiMapCfg($MAINCFG,$_GET['map']);
		$MAPCFG->readMapConfig();
		
		$FRONTEND = new WuiFrontend($MAINCFG,$MAPCFG);
		$FRONTEND->getMap();
		$FRONTEND->getMessages();
		
		if($_GET['map'] != '') {
			if(!$MAPCFG->checkMapConfigWriteable(1)) {
				exit;
			}
			if(!$MAPCFG->BACKGROUND->checkFileExists(1)) {
				exit;
			}
			if(!$MAPCFG->BACKGROUND->checkFileReadable(1)) {
				exit;
			}
    		if(!$MAPCFG->checkMapLocked(1)) {
    		    $MAPCFG->writeMapLock();
    		}
		}
	break;
}
		
// print the HTML page
$FRONTEND->printPage();
?>
